<template lang="html">

   <div class='main' id="menu_report">
      <div ref="printMe" style="text-align: center">
        <h1>Relatórios</h1>
        <div class="menu">
          <v-btn @click="generatePDF_Motoristas()"><a>Relatório de Motoristas</a></v-btn> <br/>
          <v-btn @click="generatePDF_Passageiros()"><a>Relatório de Passageiros</a></v-btn>
        </div>
      </div>
   </div>

</template>
<script lang="js">
   import jsPDF from 'jspdf';
   import autoTable from 'jspdf-autotable';
   import Motorista from '../services/motoristas'
   import Passageiro from '../services/passageiros'
   import axios from 'axios'
   
  export default  {
    props: [],
    mounted() {
      this.pegarMotoristas();
      this.pegarPassageiros();
    },
    data() {
      return {
        output : null,
        motoristas:[],
        passageiros:[],
      }
    },
    methods: {
      generatePDF_Motoristas(){
          let doc = new jsPDF();
          doc.setFontSize(22);
          doc.text('Motoristas Cadastrados', 65, 12);
          doc.setFontSize(16);
          doc.text('Samba Viagens', 85, 20);
          doc.setFontSize(12);

          let date = new Date;
          let data = ("00" + date.getDate()).slice(-2)+
                      "/"+("00" + Number(date.getMonth()+1)).slice(-2)+
                      "/"+date.getFullYear();
          let hora = ("00"+date.getHours()).slice(-2)+
                      ":"+("00"+date.getMinutes()).slice(-2)+
                      ":"+("00"+date.getSeconds()).slice(-2);

          doc.text('Data: '+data+'  Hora: '+hora, 72, 27);
          // doc.autoTable(columns, this.motoristas);
          doc.autoTable({
            head: [
              {id: '#', nome: 'Nome', 
              cidade: 'Cidade', 
              cpf: 'CPF',
              vencdocs: 'Vencimento',
              salario: 'Salário',
              obs: 'Observação'}
            ],
            body: this.motoristas,
            startY: 40,
            /* apply styling to table body */
            bodyStyles: {
                valign: 'top'
            },
            /* apply global styling */
            styles: {
                cellWidth: 'wrap',
                rowPageBreak: 'auto',
                halign: 'justify',
            },
            /* apply styling specific to table columns */
            columnStyles: {
                text: {
                    cellWidth: 'auto'
                }
            }
          });
        doc.output('dataurlnewwindow', "SambaOnibus_relatorio_Motoristas.pdf");
      },
      generatePDF_Passageiros(){
          let doc = new jsPDF();
          doc.setFontSize(22);
          doc.text('Passageiros Cadastrados', 65, 12);
          doc.setFontSize(16);
          doc.text('Samba Viagens', 85, 20);
          doc.setFontSize(12);
          let date = new Date;
          let data = ("00" + date.getDate()).slice(-2)+
                      "/"+("00" + Number(date.getMonth()+1)).slice(-2)+
                      "/"+date.getFullYear();
          let hora = date.getHours()+":"+date.getMinutes()+":"+date.getSeconds();
          doc.text('Data: '+data+'  Hora: '+hora, 72, 27);
          // doc.autoTable(columns, this.motoristas);
          doc.autoTable({
            head: [
              {
                id: '#', 
                nome: 'Nome', 
                cpf: 'CPF', 
                nascimento: 'Nascimento',
                telefone: 'Vencimento',
                cidade: 'Cidade'
              }
            ],
            body: this.passageiros,
            startY: 40,
            /* apply styling to table body */
            bodyStyles: {
                valign: 'top'
            },
            /* apply global styling */
            styles: {
                cellWidth: 'wrap',
                rowPageBreak: 'auto',
                halign: 'justify',
            },
            /* apply styling specific to table columns */
            columnStyles: {
                text: {
                    cellWidth: 'auto'
                }
            }
          });
          doc.output('dataurlnewwindow', "SambaOnibus_relatorio_Passageiros.pdf");
      },
      pegarMotoristas() {
        Motorista.listar().then(resposta => {
          let motoristas = resposta.data;
          for (let i = 0; i < motoristas.length; i++) {
              let obj = { id: motoristas[i].id,
                          nome: motoristas[i].nome, 
                          cidade: motoristas[i].cidade,
                          cpf: motoristas[i].cpf,
                          vencdocs: motoristas[i].vencdocs,
                          salario: "R$ 1600.00",
                          obs: motoristas[i].obs,
                          };
              this.motoristas.push(obj);
          }
        })
      },
      pegarPassageiros() {
        Passageiro.listar().then(resposta => {
          let passageiros = resposta.data;
          for (let i = 0; i < passageiros.length; i++) {
              let obj = {id: passageiros[i].id,
                         nome: passageiros[i].nome,
                         cpf: passageiros[i].cpf,
                         nascimento: passageiros[i].nascimento,
                         telefone: passageiros[i].telefone,
                         cidade: passageiros[i].cidade,
                      };
              this.passageiros.push(obj);
          }
        })
      },
    }
}
</script>

<style>
  #menu_report {
    margin-top: 2vw;
    background-image: url('../assets/report_icon.png');
    background-repeat: no-repeat;
    background-size: 10%;
  }

  .menu {
    margin-top: 5vw;
    color: blue;
    font-family: 'Segoe UI', Tahoma, Geneva, Verdana, sans-serif; 
    font-size: 150%;
  }

  a:hover {
    font-size: 105%;
    text-decoration: underline; 
  }
</style>